<template>
    <div class="container-fluid bg-white">
        <div class="row p-4">
            <div class="col-12 text-right">
                <button
                    class="btn btn-success"
                    @click="$modal.show('store-package', { view: 'create' })"
                >
                    Create New Product
                </button>

                <button class="btn btn-primary" @click="downloadExcel()">
                    Download Excel
                </button>
            </div>
        </div>

        <div class="bg-white overflow-wrapper">
            <table class="table">
                <thead>
                    <tr>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="packages = orderTable(packages, 'id')"
                            ></i>
                            # ID
                        </th>
                        <th>
                            <input
                                type="text"
                                class="form-control mb-2"
                                placeholder="..."
                                v-model="pattern"
                                @input="search()"
                            />
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="packages = orderTable(packages, 'name')"
                            ></i>
                            Name
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    packages = orderTable(packages, 'price')
                                "
                            ></i>
                            Price
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    packages = orderTable(
                                        packages,
                                        'created_at'
                                    )
                                "
                            ></i>
                            Created At
                        </th>
                        <th>
                            <i
                                class="fas fa-sort mr-2 pointer"
                                @click="
                                    packages = orderTable(
                                        packages,
                                        'updated_at'
                                    )
                                "
                            ></i>
                            Updated At
                        </th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(item, index) in packages" :key="index">
                        <td>{{ item.id }}</td>
                        <td>
                            <span
                                class="link-button"
                                @click="
                                    $modal.show('store-package', {
                                        view: 'edit',
                                        package: item,
                                    })
                                "
                            >
                                {{ item.name }}
                            </span>
                        </td>
                        <td>{{ item.price | digit }}</td>
                        <td>
                            {{ item.created_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                        <td>
                            {{ item.updated_at | moment("DD.MM.YYYY HH:MM") }}
                        </td>
                    </tr>
                </tbody>
                <tbody v-if="!packages.length">
                    <tr>
                        <td colspan="999999">
                            <div class="alert alert-secondary" role="alert">
                                Products list is empty !
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>

            <div v-if="isLoading" class="loader" />
        </div>

        <store-package :packages="packages" />
    </div>
</template>

<script>
import { loadMoreMixin } from "../../mixin/loadMoreMixin";

export default {
    filters: {
        digit(value) {
            if (!value) return "";
            var parts = value.toString().split(".");
            parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ".");
            parts[0] += ",00";
            return parts.join(",");
        },
    },
    mixins: [loadMoreMixin],

    data() {
        return {
            packages: [],
            pattern: "",
        };
    },

    mounted() {
        axios
            .post("/api/packages/list", {
                take: this.take,
                skip: this.skip,
                orderBy: {
                    name: "id",
                    value: "desc",
                },
            })
            .then((response) => {
                this.packages = response.data;
            });
    },

    methods: {
        search() {
            axios
                .post("/api/packages/list", {
                    pattern: this.pattern,
                    getAll: true,
                    orderBy: {
                        name: "id",
                        value: "desc",
                    },
                })
                .then((response) => {
                    this.packages = response.data;
                });
        },

        downloadExcel() {
            axios({
                url: "/export/packages",
                method: "POST",
                responseType: "blob",
            }).then((response) => {
                const url = window.URL.createObjectURL(
                    new Blob([response.data])
                );

                const link = document.createElement("a");
                link.href = url;
                link.setAttribute("download", "products.xlsx");
                document.body.appendChild(link);
                link.click();
            });
        },

        loadMore() {
            // Show loading more
            this.isLoading = true;

            // Get total products
            let length = this.packages.length;

            if (this.load && length >= 50) {
                this.timeout = setTimeout(() => {
                    this.skip += 50;

                    axios
                        .post("/api/packages/list", {
                            take: this.take,
                            skip: this.skip,
                            orderBy: {
                                name: "id",
                                value: "desc",
                            },
                        })
                        .then((response) => {
                            // Merge arrays
                            this.packages = this.packages.concat(response.data);
                            // Hide loading more
                            this.isLoading = false;
                            // disable new calls if there arent any new companies
                            length == this.packages.length
                                ? (this.load = false)
                                : (this.load = true);
                        });
                }, 500);
            } else {
                // Hide loading more
                this.isLoading = false;
            }
        },
    },
};
</script>
